"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Transaction(ProtocolElement):
    """
    A transaction having all necessary data to process it into the
    database
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
        "lastModified",
        "options",
        "requestSignature",
        "status",
        "transactionDetails",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import cva as cva_1_5_3

        return {
            "requestDetails": cva_1_5_3.RequestDetails,
            "transactionDetails": cva_1_5_3.TransactionDetails,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import cva as cva_1_5_3

        return {
            "status": cva_1_5_3.TransactionStatus,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import cva as cva_1_5_3

        return {
            "org.gel.models.cva.avro.RequestDetails": cva_1_5_3.RequestDetails,
            "org.gel.models.cva.avro.TransactionStatus": cva_1_5_3.TransactionStatus,
            "org.gel.models.cva.avro.TransactionDetails": cva_1_5_3.TransactionDetails,
            "org.gel.models.cva.avro.Transaction": cva_1_5_3.Transaction,
        }

    __slots__ = [
        "id",
        "lastModified",
        "options",
        "requestSignature",
        "status",
        "transactionDetails",
        "compressedData",
        "processingMilli",
        "requestDetails",
    ]

    def __init__(
        self,
        id,
        lastModified,
        options,
        requestSignature,
        status,
        transactionDetails,
        compressedData=None,
        processingMilli=None,
        requestDetails=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.Transaction model.

        :param id:
            The identifier of the transaction
        :type id: str
        :param lastModified:
            Timestamp of last transaction status modification
        :type lastModified: str
        :param options:
            Options to process the transaction
        :type options: dict[str, str]
        :param requestSignature:
            A MD5 hash signature of the transaction used to discard identical
            requests. To have a 50% chance of a collision by the
            birthday paradox we need 2**64 transactions
        :type requestSignature: str
        :param status:
            Transaction status
        :type status: TransactionStatus
        :param transactionDetails:
            The details of a transaction
        :type transactionDetails: TransactionDetails
        :param compressedData:
            The data to be ingested in CVA compressed
        :type compressedData: None | bytes
        :param processingMilli:
            The number of milliseconds to process the transaction.
        :type processingMilli: None | int
        :param requestDetails:
            The details of a request
        :type requestDetails: None | RequestDetails
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
